## net.sf.saxon.om
Class ReverseArrayIterator

    java.lang.Object
      net.sf.saxon.om.ReverseArrayIterator

All Implemented Interfaces:
  AxisIterator, LastPositionFinder, ReversibleIterator, SequenceIterator

public final class ReverseArrayIterator
extends java.lang.Object
implements AxisIterator, ReversibleIterator, LastPositionFinder

ReverseArrayIterator is used to enumerate items held in an array in reverse order.

Constructor Summary
`ReverseArrayIterator(Item[] items, int start, int end)` Create an iterator a slice of an array

Method Summary
`Item` `current()` Get the current item in the sequence.
`SequenceIterator` `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence
`int` `getLastPosition()` Get the last position (that is, the number of items in the sequence)
`SequenceIterator` `getReverseIterator()` Get an iterator that processes the same items in reverse order.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ReverseArrayIterator

    public ReverseArrayIterator(Item[] items,
                                int start,
                                int end)

  Create an iterator a slice of an array

Parameters:
  `items` - The array of items
  `start` - The first item in the array to be be used (this will be the last one in the resulting iteration). Zero-based.
  `end` - The item after the last one in the array to be used (this will be the first one to be returned by the iterator). Zero-based.

Method Detail

### next

    public Item next()

  Description copied from interface: `AxisIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `AxisIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public Item current()

  Description copied from interface: `AxisIterator`
  Get the current item in the sequence.

  Specified by:
    `current` in interface `AxisIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Description copied from interface: `AxisIterator`
  Get the current position

  Specified by:
    `position` in interface `AxisIterator`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### getLastPosition

    public int getLastPosition()

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence)

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`

### getAnother

    public SequenceIterator getAnother()

  Description copied from interface: `AxisIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence

  Specified by:
    `getAnother` in interface `AxisIterator`
  Returns:
    a new iterator over the same sequence

### getReverseIterator

    public SequenceIterator getReverseIterator()

  Get an iterator that processes the same items in reverse order. Since this iterator is processing the items backwards, this method returns an ArrayIterator that processes them forwards.

  Specified by:
    `getReverseIterator` in interface `ReversibleIterator`
  Returns:
    a new ArrayIterator